function [fun,dfun,ifun,x0,m,C,Ax] = zasin
% Taylor series coefficient lists for several functions.
% Pm(x) = c(1) + c(2)x + c(2)x^2 + ... + c(m+1)x^m
% fun  is the function, output.
% dfun is the derivative, output.
% ifun is the integral, output.
% x0 is the point of expansion, output.
% m  is the degree of the polynomial, output.
% C  is the coefficient list, output.
% Ax contains three asis vectors plotting, output.
x0 = 0; 
m = 25;
a = -0.999999;
b = 0.999999;
ymin = -pi/2;
ymax = pi/2;
ymin1 = 0;
ymax1 = 5;
ymin2 = 0;
ymax2 = 1;
Ax(1,:) = [a b ymin ymax];
Ax(2,:) = [a b ymin1 ymax1];
Ax(3,:) = [a b ymin2 ymax2];
fun = 'asin(x)';
dfun = 'sqrt(1 - x.^2).^(-1)';
ifun = '-1+sqrt(1 - x.^2) + x.*asin(x)';
C = [676039/104857600,
0,
88179/12058624,
0,
46189/5505024,
0,
12155/1245184,
0,
6435/557056,
0,
143/10240,
0,
231/13312,
0,
63/2816,
0,
35/1152,
0,
5/112,
0,
3/40,
0,
1/6,
0,
1,
0];

