function [fun,dfun,ifun,x0,m,C,Ax] = zatan
% Taylor series coefficient lists for several functions.
% Pm(x) = c(1) + c(2)x + c(2)x^2 + ... + c(m+1)x^m
% fun  is the function, output.
% dfun is the derivative, output.
% ifun is the integral, output.
% x0 is the point of expansion, output.
% m  is the degree of the polynomial, output.
% C  is the coefficient list, output.
% Ax contains three asis vectors plotting, output.
x0 = 0; 
m = 25;
a = -1;
b = 1;
ymin = -1;
ymax = 1;
ymin1 = 0;
ymax1 = 1;
ymin2 = 0;
ymax2 = 0.5;
Ax(1,:) = [a b ymin ymax];
Ax(2,:) = [a b ymin1 ymax1];
Ax(3,:) = [a b ymin2 ymax2];
fun = 'atan(x)';
dfun = '(1 + x.^2).^(-1)';
ifun = 'x.*atan(x) - log(1 + x.^2)/2';
C = [1/25,
0,
-1/23,
0,
1/21,
0,
-1/19,
0,
1/17,
0,
-1/15,
0,
1/13,
0,
-1/11,
0,
1/9,
0,
-1/7,
0,
1/5,
0,
-1/3,
0,
1,
0];
