function [fun,dfun,ifun,x0,m,C,Ax] = zlogq
% Taylor series coefficient lists for several functions.
% Pm(x) = c(1) + c(2)x + c(2)x^2 + ... + c(m+1)x^m
% fun  is the function, output.
% dfun is the derivative, output.
% ifun is the integral, output.
% x0 is the point of expansion, output.
% m  is the degree of the polynomial, output.
% C  is the coefficient list, output.
% Ax contains three asis vectors plotting, output.
x0 = 0; 
m = 25;
a = -0.9;
b = 0.9;
ymin = -3;
ymax = 3;
ymin1 = 0;
ymax1 = 10;
ymin2 = 0;
ymax2 = 1;
Ax(1,:) = [a b ymin ymax];
Ax(2,:) = [a b ymin1 ymax1];
Ax(3,:) = [a b ymin2 ymax2];
fun = 'log(1+x)-log(1-x)';
dfun = '(1-x).^(-1) + (1+x).^(-1)';
ifun = '-x.*log(1-x)+log(-1+x)+log(1+x)+x.*log(1+x)';
C = [2/25,
0,
2/23,
0,
2/21,
0,
2/19,
0,
2/17,
0,
2/15,
0,
2/13,
0,
2/11,
0,
2/9,
0,
2/7,
0,
2/5,
0,
2/3,
0,
2,
0];
