function [fun,dfun,ifun,x0,m,C,Ax] = ztan
% Taylor series coefficient lists for several functions.
% Pm(x) = c(1) + c(2)x + c(2)x^2 + ... + c(m+1)x^m
% fun  is the function, output.
% dfun is the derivative, output.
% ifun is the integral, output.
% x0 is the point of expansion, output.
% m  is the degree of the polynomial, output.
% C  is the coefficient list, output.
% Ax contains three asis vectors plotting, output.
x0 = 0; 
m = 25;
a = -1.5;
b = 1.5;
ymin = -10;
ymax = 10;
ymin1 = 0;
ymax1 = 15;
ymin2 = 0;
ymax2 = 3;
Ax(1,:) = [a b ymin ymax];
Ax(2,:) = [a b ymin1 ymax1];
Ax(3,:) = [a b ymin2 ymax2];
fun = 'tan(x)';
dfun = 'cos(x).^(-2)';
ifun = '-log(cos(x))';
C = [58870668456604/3698160658676859375,
0,
113927491862/2900518163668125,
0,
18888466084/194896477400625,
0,
443861162/1856156927625,
0,
6404582/10854718875,
0,
929569/638512875,
0,
21844/6081075,
0,
1382/155925,
0,
62/2835,
0,
17/315,
0,
2/15,
0,
1/3,
0,
1,
0];
