echo off;
% NUMERICAL METHODS: MATLAB Programs, (c) John H. Mathews 1994
% To accompany the text:
% NUMERICAL METHODS for Mathematics, Science and Engineering, 2nd Ed, 1992
% Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
% This free software is complements of the author.

% Algorithm 9.3 (Taylor's Method of Order 4).
% Section	9.4,	Taylor Series Method, Page 448
echo on; clc; format long; hold off; clear

% This program implements Taylor's method

% for solving the initial value problem

%     y' = f(t,y)    with    y(a) = y0

%	Define and store the function d1 = f(t,y)	
% and formulas for the next three derivatives
% of  f(t,y)  in the M-file  df.m 
% function z = df(t,y)
% d1 = (t - y)/2;
% d2 = (2 - t + y)/4;
% d3 = (- 2 + t - y)/8;
% d4 = (2 - t + y)/16;
% z = [d1 d2 d3 d4];

delete df.m
diary df.m; disp('function z = df(t,y)');...
            disp('d1 = (t - y)/2;');...
            disp('d2 = (2 - t + y)/4;');...
            disp('d3 = (- 2 + t - y)/8;');...
            disp('d4 = (2 - t + y)/16;');...
            disp('z = [d1 d2 d3 d4];');...
diary off;

df(0,0); % Remark. df.m and taylor.m are used for Algorithm 9.3
pause	   % Press any key to continue.

clc;

%	Place the endpoints of [a,b] in  a  and  b.

%	Place the initial value y(a) in  ya.

%	Place the number of subintervals in  m.

a  = 0;
b  = 3;
ya = 1;
m  = 12;

[T,Y] = taylor('df',a,b,ya,m);
points = [T;Y];

pause	% Press any key to see the list of solution points.

clc;, clg;
c = 0;
d = 1.75;
axis([a b c d]);...
plot(T,Y,'g');...
hold on;...
plot([a b],[0 0],'b',[0 0],[c d],'b');...
if m<=30,
  plot(T,Y,'or');
end;...
xlabel('t');...
ylabel('y');...
title('Taylor`s solution to y` = f(t,y)');...
grid;...
axis;...
hold off;...
shg; pause	% Press any key to continue.

Mx1 = 'Taylor`s solution to y` = f(t,y).';
Mx2 = '     t(k)               y(k)';
clc,echo off,diary output,...
disp(''),disp(Mx1),...
disp(''),disp(Mx2),disp(points'),diary off,echo on
