LANGUAGE = English
EVERYTHING = HoWS
MAKEFILE = {EVERYTHING}.make
SIGNATURE = HoWS
APPLICATION = HoWSample
HELPFILEVERSION = 0x0110
HELPFILEVERSIONSTRING = 1.1
HELPFILE = {APPLICATION} Help
HELPFILEALIAS = {HELPFILE} alias
HELPDOCFILE = {APPLICATION}.doc
HELPPICTSFILE = {APPLICATION}.picts
HOWDIR = ::
HOWWRAP = {HOWDIR}wrap
HOWCVRT = {HOWDIR}cvrt
HOWLIB = {HOWDIR}HoWLib
HOWI = 1024
HOWT = 1024
HOWG = 1024
HOWC = 1024
HOWA = 1024
HOWRESFILE = {HOWDIR}HoWRez.{LANGUAGE}.r
RESFILE = {APPLICATION}.r
RESHFILE = {APPLICATION}.r.h
HFILE = {APPLICATION}.h
HOWLIBHFILE = {HOWLIB}.h
SOURCES = {APPLICATION}.c
OBJECTS = {APPLICATION}.c.o
HOWLIBOBJECTS = {HOWLIB}.o
SOUNDSFILE = {APPLICATION}.sounds

# Define current version of help file.
COptions = -d helpFileVersion={HELPFILEVERSION}

{EVERYTHING}  {HELPFILE} {APPLICATION}
	
{HELPFILE}  {MAKEFILE} {HELPDOCFILE} {HELPPICTSFILE} {HOWRESFILE}
	{HOWWRAP} -r 335 -p <{HELPDOCFILE} | 
		{HOWCVRT} -o {Targ} -i {HOWI} -t {HOWT} -g {HOWG} -c {HOWC} 
			-p {HELPPICTSFILE} -w 345 -h 12
	Rez -t 'HoW!' -c 'HoW?' 
		-d version={HELPFILEVERSION} -d versionString="{HELPFILEVERSIONSTRING}" 
		-d HoWi={HOWI} -d HoWt={HOWT} -d HoWg={HOWG} -d HoWc={HOWC} -d HoWa={HOWA} 
		-d application="{APPLICATION}" 
		{HOWRESFILE} -a -o {Targ}
	Echo "include "`echo `Directory``{HELPPICTSFILE}";" | 
		Rez Dev:StdIn -a -o {Targ}

{APPLICATION}  {MAKEFILE} {RESFILE}
	Rez -d helpFileVersionString="{HELPFILEVERSIONSTRING}" 
		{RESFILE} -a -o {Targ}
	SetFile -a BiM {Targ}

{RESFILE}  {RESHFILE} {HELPFILEALIAS} {SOUNDSFILE}
	SetFile -m . {Targ}

{HELPFILEALIAS} 
	Echo "Please use Finder to make an alias to {HELPFILE}, then build this program again."
	Exit 1

{APPLICATION}  {MAKEFILE} {OBJECTS} {HOWLIBOBJECTS}
	Link -w -t APPL -c {SIGNATURE} 
		{OBJECTS} 
		{HOWLIBOBJECTS} 
		"{CLibraries}"StdClib.o 
		"{CLibraries}"CInterface.o 
		"{CLibraries}"CRuntime.o 
		"{Libraries}"Interface.o 
		-o {Targ}
	
{SOURCES}  {HFILE} {HOWLIBHFILE}
	SetFile -m . {Targ}
	
{HFILE}  {RESHFILE}
	SetFile -m . {Targ}
