/* HoWSample.r - resources for Help on Wheels sample application */

/* to compile: BuildProgram HoWS */

/* - - - - - - - - - - - an AWOL Software Production - - - - - - - - - - - */
/* - - - - - - - - - - - - - (c) 1994 Ross Brown - - - - - - - - - - - - - */
/* - - - - - - - - -  Email:  ab026@freenet.carleton.ca  - - - - - - - - - */

#define	SystemSevenOrLater	1
#include	"BalloonTypes.r"
#include	"Types.r"
#include	"SysTypes.r"

#include	"HoWSample.r.h"

resource 'ALRT' (rAboutAlert, "About HoWSample", purgeable) {
	{0, 0, 66, 360},
	rAboutAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	},
	alertPositionMainScreen
};

resource 'DITL' (rAboutAlert, "About HoWSample", purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{28, 283, 48, 351},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 8, 58, 273},
		StaticText {
			disabled,
			"HoWSample version 1.1\n"
			"an AWOL Software Production\n"
			" 1994 Ross Brown"
			/* Your application must include a copyright notice containing the following text: */
			/* Help interface portion Copyright  1994 Ross Brown. */
		},
		/* [3] */
		{0, 0, 0, 0},
		HelpItem {
			disabled,
			HMScanhdlg {
				rAboutAlert
			}
		}
	}
};

resource 'hdlg' (rAboutAlert, purgeable) {
	HelpMgrVersion,
	0,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMSkipItem {
		},
		HMStringItem {
			{0, 0},
			{0, 0, 0, 0},
			"",
			"Use the Help menu to learn more about HoWSample.  This application offers help via the Help on Wheels help server application, as well as Balloon Help.",
			"",
			""
		}
	}
};

resource 'ALRT' (rGeneralAlert, "General", preload) {
	{0, 0, 130, 368},
	rGeneralAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	},
	alertPositionMainScreen
};

resource 'DITL' (rGeneralAlert, "General", preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{100, 299, 120, 358},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 87, 358},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DLOG' (rDoNothingDialog, "Do-Nothing", purgeable) {
	{0, 0, 100, 200},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	rDoNothingDialog,
	"",
	alertPositionMainScreen
};

resource 'dctb' (rDoNothingDialog, "Do-Nothing", purgeable) {
	{	/* array ColorSpec: 0 elements */
	}
};

resource 'DITL' (rDoNothingDialog, "Do-Nothing", purgeable) {
	{	/* array DITLarray: 2 elements */
		/* [1] - iDNDSqueak */
		{40, 60, 60, 140},
		Button {
			enabled,
			"Squeak"
		},
		/* [2] */
		{0, 0, 0, 0},
		HelpItem {
			disabled,
			HMScanhdlg {
				rDoNothingDialog
			}
		}
	}
};

resource 'hdlg' (rDoNothingDialog, purgeable) {
	HelpMgrVersion,
	0,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMStringItem {
			{0, 0},
			{0, 0, 0, 0},
			"Click here to make an objectionable noise and close the dialog box.",
			"",
			"",
			""
		}
	}
};

type 'HoWS' as 'STR ';

resource 'HoWS' (0, purgeable) {
	"HoWSample version 1.1  an AWOL Software Production  1994 Ross Brown"
};

resource 'vers' (1, purgeable) {
	0x1,
	0x10,
	release,
	0x0,
	verUs,
	"1.1",
	"1.1an AWOL Software Production  1994 Ross Brown"
};

resource 'vers' (2, purgeable) {
	0x1,
	0x10,
	release,
	0x0,
	verUS,
	"1.1",
	"AWOL Utilities 1.1"
};

type 'Lang' {
	unsigned	integer;								/* language code */
};

resource 'Lang' (128) {
	0													/* langEnglish */
};

include "HoWSample Help alias" 'alis' (0) as 'alis' (rHelpFileAlias);

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	60 * 1024,
	50 * 1024
};

resource 'hfdr' (kHMHelpID) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	{
		HMStringItem {
		   "This application is a sample client of the Help on Wheels help server.  Its help file is a manual describing how to write a help client application."
		}
	}
};

resource 'BNDL' (128) {
	'HoWS',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 128,
			/* [2] */
			1, 129,
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, rPrincipalIconFamily
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'FREF' (129) {
	'pref',
	1,
	""
};

resource 'ICN#' (rPrincipalIconFamily, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0001 0000 0002 8000 0004 4000 0009 2000"
		$"0010 9000 0022 4800 0045 2400 0088 8200"
		$"0105 0900 0242 0080 0421 0040 0890 8020"
		$"1108 0010 24A5 0008 4242 3F04 9128 4082"
		$"4A90 8041 2441 3022 1221 C814 090E 7F8F"
		$"0492 3007 0221 0007 0140 8007 0080 6007"
		$"0040 1FE7 0020 021F 0010 0407 0008 0800"
		$"0004 1000 0002 2000 0001 4000 0000 80",
		/* [2] */
		$"0001 0000 0003 8000 0007 C000 000F E000"
		$"001F F000 003F F800 007F FC00 00FF FE00"
		$"01FF FF00 03FF FF80 07FF FFC0 0FFF FFE0"
		$"1FFF FFF0 3FFF FFF8 7FFF FFFC FFFF FFFE"
		$"7FFF FFFF 3FFF FFFE 1FFF FFFC 0FFF FFFF"
		$"07FF FFFF 03FF FFFF 01FF FFFF 00FF FFFF"
		$"007F FFFF 003F FE1F 001F FC07 000F F800"
		$"0007 F000 0003 E000 0001 C000 0000 80"
	}
};

resource 'MENU' (mApple) {
	mApple,
	textMenuProc,
	allEnabled,
	enabled,
	apple,
	{	/* array: 1 elements */
		/* [1] */
		"About HoWSample", noIcon, noKey, noMark, plain
	}
};

resource 'hmnu' (mApple, purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMSkipItem {
		},
		HMStringItem {
			"Shows HoWSample credit and version information.",
			"",
			"",
			""
		}
	}
};

resource 'MENU' (mFile) {
	mFile,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	{	/* array: 1 elements */
		/* [1] - iQuit */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'hmnu' (mFile, purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMStringItem {
			"File menu\n\nUse this menu to quit HoWSample.",
			"",
			"",
			""
		},
		HMStringItem {
			"Quits HoWSample.",
			"",
			"",
			""
		}
	}
};

resource 'MENU' (mEdit) {
	mEdit,
	textMenuProc,
	0x7FFFFFC0,
	disabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] - iUndo */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] - iCut */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] - iCopy */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] - iPaste */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] - iClear */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'hmnu' (mEdit, purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMStringItem {
			"Edit menu\n\nUse this menu to work with text.",
			"Edit menu\n\nNot available because HoWSample has no editing functions.",
			"",
			""
		},
		HMStringItem {
			"",
			"Not available because HoWSample does not allow actions to be undone.",
			"",
			""
		},
		HMSkipItem {
		},
		HMStringItem {
			"Removes the selected text and places it in the Clipboard.",
			"Removes the selected text and places it in the Clipboard.  Not available because no text is selected.",
			"",
			""
		},
		HMStringItem {
			"Places a copy of the selected text in the Clipboard.  The selected text remains where it is.",
			"Places a copy of the selected text in the Clipboard.  Not available because no text is selected.",
			"",
			""
		},
		HMStringItem {
			"Places the contents of the Clipboard at the insertion point, or in place of the current selection.",
			"Places the contents of the Clipboard at the insertion point, or in place of the current selection.  Not available because there is no text in the Clipboard, or because no text is being edited.",
			"",
			""
		},
		HMStringItem {
			"Removes the selected text without placing it in the Clipboard.",
			"Removes the selected text without placing it in the Clipboard.  Not available because no text is selected.",
			"",
			""
		}
	}
};

resource 'MENU' (mDemo) {
	mDemo,
	textMenuProc,
	allEnabled,
	enabled,
	"Demo",
	{	/* array: 1 elements */
		/* [1] - iDoNothing */
		"Do-Nothing", noIcon, "D", noMark, plain
	}
};

resource 'hmnu' (mDemo, purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMStringItem {
			"Demo menu\n\nUse this menu for a demonstration of how to attach help information to menus and dialogs.",
			"",
			"",
			""
		},
		HMStringItem {
			"Does nothing, except bring up the do-nothing dialog.",
			"",
			"",
			""
		}
	}
};

resource 'hmnu' (kHMHelpMenuID, purgeable) {
	HelpMgrVersion,
	hmDefaultOptions,
	0,
	0,
	HMSkipItem {
	},
	{
		HMStringItem {
			"Displays tutorial help for HoWSample using the Help on Wheels help server application.",
			"Not available, perhaps because the HoWSample Help file is missing or invalid.",
			"",
			""
		},
		HMSkipItem {
		},
		HMStringItem {
			"Displays help about HoWSample dialogs using the Help on Wheels help server application.",
			"Not available, perhaps because the HoWSample Help file is missing or invalid.",
			"",
			""
		},
		HMStringItem {
			"Displays help about HoWSample menus using the Help on Wheels help server application.",
			"Not available, perhaps because the HoWSample Help file is missing or invalid.",
			"",
			""
		}
	}
};

resource 'MBAR' (rMenuBar, preload) {
	{	/* array MenuArray: 4 elements */
		/* [1] */
		mApple,
		/* [2] */
		mFile,
		/* [3] */
		mEdit,
		/* [4] */
		mDemo
	}
};

include "HoWSample.sounds";

resource 'STR#' (rMessages, purgeable) {
	{	/* array StringArray: 13 elements */
		/* [1] - iGenericErrorMessage */
		"An internal error has occurred.  Please contact the author as described in HoWSample Help, citing error number %d.",
		/* [2] - iHelpNotAvailable */
		"Help is not available.  The HoWSample Help file may be missing or invalid.",
		/* [3] - iHoWSampleRequiresAppleEvents */
		"HoWSample requires Apple events.",
		/* [4] - iHoWSampleRequiresFolderManager */
		"HoWSample requires the Folder Manager.",
		/* [5] - iHoWSampleRequiresProcessManager */
		"HoWSample requires the Process Manager.",
		/* [6] - iHoWSampleRequiresAliasManager */
		"HoWSample requires the Alias Manager.",
		/* [7] - iHoWSampleRequiresEnhancedStandardFile */
		"HoWSample requires the enhanced Standard File procedures.",
		/* [8] - iHoWSampleRequiresWaitNextEvent */
		"HoWSample requires the _WaitNextEvent trap.",
		/* [9] - iHoWRegisterFailed */
		"HoWSample failed to register with the help server.",
		/* [10] - iPreferencesFileUnwritable */
		"The preferences file is locked or otherwise unwritable.",
		/* [11] - iHoWSampleRequiresFSSpecCalls */
		"HoWSample requires the FSSpec calls.",
		/* [12] - iHelpFileWrongVersion */
		"The HoWSample Help file appears to be the wrong version.  Please delete it or replace it with version " helpFileVersionString ".",
		/* [13] - iPreferencesFileUnreadable */
		"The preferences file cannot be opened.",
	}
};

resource 'STR#' (rPreloadStrings, preload) {
	{	/* array StringArray: 5 elements */
		/* [1] - iHoWSamplePreferencesFileName */
		"HoWSample Preferences",
		/* [2] - iHoWSampleHelpFileName */
		"HoWSample Help",
		/* [3] - iHelpCommandChar */
		"/",
		/* [4] - iDialogHelpString */
		"Dialog Help",
		/* [5] - iMenuHelpString */
		"Menu Help",
	}
};